function varargout = VisRedGUI(varargin)
% VisRedGUI M-file for VisRedGUI.fig
%      VisRedGUI, by itself, creates a new VisRedGUI or raises the existing
%      singleton*.
%
%      H = VisRedGUI returns the handle to a new VisRedGUI or the handle to
%      the existing singleton*.
%
%      VisRedGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in VisRedGUI.M with the given input arguments.
%
%      VisRedGUI('Property','Value',...) creates a new VisRedGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before VisRedGUI_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to VisRedGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES
%
% Suported by CLASSE Project POSC/EEI/58162/2004 FCT and FEDER
% Created by Antnio Dourado, Edgar Ferreira, Paulo Barbeiro - FCTUC
% dourado@dei.uc.pt, edgars@student.dei.uc.pt, barbeiro@student.dei.uc.pt
% Updated April 20, 2007
%
% Copyright (C) 2007 Antnio Dourado, Edgar Ferreira, Paulo Barbeiro  FCTUC Coimbra, Portugal
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% To cite this work:
%
%           Dourado A., E. Ferreira, P. Barbeiro, VISRED Numerical Data Mining with Linear and
%           Nonlinear Techniques, P. Perner (Ed.): ICDM 2007, LNAI 4597, pp. 92106, 2007.
%           Springer-Verlag Berlin Heidelberg 2007
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.

% Edit the above text to modify the response to help VisRedGUI

% Last Modified by GUIDE v2.5 12-Mar-2007 10:32:20

% Begin initialization code - DO NOT EDIT

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @VisRedGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @VisRedGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

%% STRUCTURES DEFINITION
% 
% - labels:         structure containing datacursor labels
% - clust_load:     structure containing data from "Load Clustered Data"

% --- Executes just before VisRedGUI is made visible.
function VisRedGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to VisRedGUI (see VARARGIN)

% Add necessary paths to Matlab
handles.path=pwd;
addpath([handles.path '\dimensionReductionFunctions']);
addpath([handles.path '\nlpcaFunctions']);
addpath([handles.path '\somtoolbox']);     
addpath([handles.path '\rsomtoolbox']);
addpath([handles.path '\clusteringFunctions']);

% Choose default command line output for VisRedGUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes VisRedGUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% Display GNU License
disp(strvcat(' ','VISRED v1.2r, Copyright (C) 2007 Antnio Dourado, Edgar Ferreira, Paulo Barbeiro',' ',...
'VISRED comes with ABSOLUTELY NO WARRANTY; for details',...
'type "help VisRedGUI".  This is free software, and you are welcome',...
'to redistribute it under certain conditions;',...
'see "License EN.txt" or "License PT.txt" for more details',' '))

% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Remove added paths to Matlab
rmpath([handles.path '\dimensionReductionFunctions']);
rmpath([handles.path '\nlpcaFunctions']);
rmpath([handles.path '\somtoolbox']);     
rmpath([handles.path '\rsomtoolbox']);
rmpath([handles.path '\clusteringFunctions']);


% Hint: delete(hObject) closes the figure
delete(hObject);


% --- Outputs from this function are returned to the command line.
function varargout = VisRedGUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


%%              RAW  DATA  PANEL  FUNCTIONS
%
%

% --- Executes on button press in select_exel_file_button.
function select_exel_file_button_Callback(hObject, eventdata, handles)
% hObject    handle to select_exel_file_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    [filename, path] = uigetfile( ...
    {'*.xls', 'Excel files(*.xls)'; ...
%    '*.*','All Files (*.*)' ...
    },'Select Excel file to load');
    if(filename~=0)
        [typ, desc] = xlsfinfo([path filename]);
        set(handles.excel_sheet_list,'String',desc);
        handles.sourcefile.filename=filename;
        handles.sourcefile.path=path;
    %set visibilities for read panel elements
        set([handles.excel_sheet_list,...
        handles.start_txt...
        handles.end_txt...
        handles.start_edit...
        handles.read_raw_button...
        handles.end_edit],'enable','on');
    else if strcmp(get(handles.excel_sheet_list,'enable'),'on')
        set([handles.excel_sheet_list,...
        handles.start_txt...
        handles.end_txt...
        handles.start_edit...
        handles.read_raw_button...
        handles.end_edit],'enable','off');    
        end
    end
    % Update handles structure
     guidata(hObject, handles);    
   

% --- Executes on button press in read_raw_button.
function read_raw_button_Callback(hObject, eventdata, handles)
% hObject    handle to read_raw_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%gets values in edit boxes, and in list
    cel_i=  get(handles.start_edit,'String');
    cel_f=  get(handles.end_edit,'String');
    list=get(handles.excel_sheet_list,'String');
    val=get(handles.excel_sheet_list,'Value');
%read the data from exel file. 'original' keeps the numeric data, and 't' the text data
    [original,t]=xlsread([handles.sourcefile.path handles.sourcefile.filename],...
        list{val},strcat(cel_i,':',cel_f));
%generates normalized Data
    handles.rawData = ClasseNormalization(original);
%Reads/Generates Labels
    handles.labels = decodeExcelData(original,t);
%set current data
    handles.current_data=handles.rawData.original;
%updates raw log
    set(handles.raw_log,'String',{'Data:';handles.sourcefile.filename;list{val};[cel_i ':' cel_f]});
%set visibilities, and default popupmenus values.
    set(handles.raw_log_panel,'visible','on');
    set(handles.dissimilarities_panel,'visible','on');
    set(handles.var_red_method_panel,'visible','on');
    set(handles.MDS_parameters,'visible','on');
    set(handles.normalization_pp,'value',1);
    set(handles.diss_mink_pp,'value',3);
    set(handles.mds_nr_dim_pp,'value',2);
    set(handles.p_symb_pp,'value',6);

% Set SOM Clustering available for original data
check=get([handles.panel_alg],'visible');
if strcmp(check,'off')
    set([handles.panel_alg handles.panel_som handles.panel_clust_info],'visible','on');
    set(handles.panel_create_clusters,'visible','on');
    sel=get(handles.par6_0,'Value');
    if sel==1
        set(handles.create_clusters,'String','Open SOM Guide');
    elseif sel==2
        set(handles.create_clusters,'String','Open RecSOM Guide');
    end
    set([handles.clust_dim handles.dim_text],'enable','off');
    set([handles.clust_alg handles.par6_1],'Enable','off');
    set([handles.clust_alg],'Value',6);
    set([handles.par6_1],'Value',2);
    set([handles.list_clust_info],'String','Loaded data is available in SOM Networks.');
end

% Disable load file and Saves
set([handles.load_file handles.save_red handles.rad_mat handles.rad_xls handles.save],'Enable','off');

% Update handles structure
guidata(hObject, handles);


% --- Executes on selection change in normalization_pp.
function normalization_pp_Callback(hObject, eventdata, handles)
% hObject    handle to normalization_pp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%rawData structure field names must be changed on
%dimensionReductionMethods\ClasseNormalization

% Determine the selected data set.
      str = get(hObject,'String');
      val = get(hObject,'Value');
      % Set current data to the selected data set.
      switch str{val};
        case 'Off' 
            handles.current_data=handles.rawData.original;
        case 'Mean value only' 
            handles.current_data=handles.rawData.n_mean;
        case 'Standard Deviation Only' 
            handles.current_data=handles.rawData.n_wiseStD;
        case 'On' 
            handles.current_data=handles.rawData.norm;
      end
 guidata(hObject, handles); % Save handles


% --- Executes during object creation, after setting all properties.
function normalization_pp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to normalization_pp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in raw_plot_button.
function raw_plot_button_Callback(hObject, eventdata, handles)
% hObject    handle to raw_plot_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    str = get(handles.normalization_pp,'string');
    val = get(handles.normalization_pp,'value');
    fraw=figure('name',['RawData - ' str{val}],'numberTitle','off');
    auxiliarInfo = plot(handles.current_data);
    axis([0 size(handles.current_data,1),min(min(handles.current_data)),max(max(handles.current_data))]);
    if (size(handles.current_data,2)<6)
        legend(handles.name_vars);
    end
    dcm_obj = datacursormode(fraw);
    set(dcm_obj,'DisplayStyle','datatip','SnapToDataVertex','on',...
        'Enable','on','UpdateFcn',{@rawLabelsFunction,handles.labels,dcm_obj,auxiliarInfo})

% --- Executes on button press in boxplot_button.
function boxplot_button_Callback(hObject, eventdata, handles)
% hObject    handle to boxplot_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%boxplot current data defined in normalization popupmenu
    figure('name','Boxplot','numbertitle','off');
    boxplot(handles.current_data,'orientation','horizontal','labels',handles.labels.varNames);   

% --- startCell EditBox --- Matlab generated code
function start_edit_Callback(hObject, eventdata, handles)
function start_edit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
% --- endCell editBox --- Matlab generated code
function end_edit_Callback(hObject, eventdata, handles)
function end_edit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
% --- excel_sheet_list --- Matlab generated code
function excel_sheet_list_Callback(hObject, eventdata, handles)
function excel_sheet_list_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    
    

%% VARIABLE REDUCTION FUNCTIONS

%% - Dissimilarities
% --- Executes on selection change in diss_metric_pp.
function diss_metric_pp_Callback(hObject, eventdata, handles)
% hObject    handle to diss_metric_pp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns diss_metric_pp contents as cell array
%        contents{get(hObject,'Value')} returns selected item from diss_metric_pp

%in Minkowski metric, shows popupmenu for factor choice
    val = get(hObject,'Value');
    if(val~=6)
        set(handles.diss_mink_pp,'visible','off');
    else 
        set(handles.diss_mink_pp,'visible','on');
    end

% --- Executes during object creation, after setting all properties.
function diss_metric_pp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to diss_metric_pp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- diss_mink_pp --- Matlab automatic generated code
function diss_mink_pp_Callback(hObject, eventdata, handles)
function diss_mink_pp_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
    
%% - Variable Reduction

% --- Executes on selection change in var_red_pp.
function var_red_pp_Callback(hObject, eventdata, handles)
% hObject    handle to var_red_pp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: contents = get(hObject,'String') returns var_red_pp contents as cell array
%        contents{get(hObject,'Value')} returns selected item from var_red_pp
    str = get(hObject,'String');
    val = get(hObject,'Value');
    %Shows or hide the Dimenension Box and text for MDS
    switch str{val};
        case 'Classical MD Scaling' 
            %set(handles.MDS_parameters,'enable','off');
            set([handles.mds_nr_dim_txt,...
            handles.mds_nr_dim_pp...
            handles.criterion_txt...
            handles.criterion_pp...
            handles.mds_start_txt...
            handles.mds_start_pp...            
            handles.max_iter_txt...
            handles.max_iter_edit...            
            handles.tolfun_txt...
            handles.tolfun_edit...        
            handles.tolx_txt...
            handles.tolx_edit...        
            handles.mds_metric_txt...
            handles.mds_metric_pp...        
            handles.mds_mink_pp,...
            handles.mds_disp_txt,...
            handles.mds_disp_pp],'enable','off');
            %set(handles.Dissimilarities,'enable','on');
            set([handles.dissimilarities_txt,...
            handles.diss_metric_pp...
            handles.diss_mink_pp],'enable','on');

        case 'Multi Dimensional Scaling' 
            %set(handles.MDS_parameters,'enable','on');
            set([handles.mds_nr_dim_txt,...
            handles.mds_nr_dim_pp,...
            handles.criterion_txt,...
            handles.criterion_pp,...
            handles.mds_start_txt,...
            handles.mds_start_pp,...            
            handles.max_iter_txt,...
            handles.max_iter_edit,...            
            handles.tolfun_txt,...
            handles.tolfun_edit,...        
            handles.tolx_txt,...
            handles.tolx_edit,...        
            handles.mds_metric_txt,...
            handles.mds_metric_pp,...        
            handles.mds_mink_pp,...
            handles.mds_disp_txt,...
            handles.mds_disp_pp],'enable','on');
            %set(handles.Dissimilarities,'enable','on');
            set([handles.dissimilarities_txt,...
            handles.diss_metric_pp...
            handles.diss_mink_pp],'enable','on');
        
        case 'PCA' 
            %set(handles.MDS_parameters,'enable','off');
            set([handles.mds_nr_dim_txt,...
            handles.mds_nr_dim_pp...
            handles.criterion_txt...
            handles.criterion_pp...
            handles.mds_start_txt...
            handles.mds_start_pp...            
            handles.max_iter_txt...
            handles.max_iter_edit...            
            handles.tolfun_txt...
            handles.tolfun_edit...        
            handles.tolx_txt...
            handles.tolx_edit...        
            handles.mds_metric_txt...
            handles.mds_metric_pp...        
            handles.mds_mink_pp,...
            handles.mds_disp_txt,...
            handles.mds_disp_pp],'enable','off');
            %set(handles.Dissimilarities,'enable','off');
            set([handles.dissimilarities_txt,...
            handles.diss_metric_pp...
            handles.diss_mink_pp],'enable','off');
    end

% --- Executes during object creation, after setting all properties.
function var_red_pp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to var_red_pp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in var_red_calc_button.
function var_red_calc_button_Callback(hObject, eventdata, handles)
% hObject    handle to var_red_calc_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
tic
%CONSTANT - MINIMUN VALUE OF EIGENS FOR BEING DISCARDED
mEV = 0.00001;


%Reads data from popupmenus
str1 = get(handles.normalization_pp,'String');
val1 = get(handles.normalization_pp,'Value');
str2 = get(handles.diss_metric_pp,'String');
val2 = get(handles.diss_metric_pp,'Value');
str3 = get(handles.var_red_pp,'String');
val3 = get(handles.var_red_pp,'Value');

% calculates the reconstructed matrix of data for both MDS or CMD, and
% actualizes raw_log file

switch str3{val3};
    
    case 'Classical MD Scaling'

        %calculate dissimilarity matrix and Text for figure and raw_log, taking
        %atention for minkowski special case
        if (val2==6)
            mink_val = get(handles.diss_mink_pp,'Value');
            D=pdist(handles.current_data,'minkowski',mink_val);
            dissMethod=[str2{val2} ' - ' num2str(mink_val)];
        else
            D=pdist(handles.current_data,str2{val2});
            dissMethod=str2{val2};
        end
        
        %calculates CMD
        [handles.reducedData.dataMatrix,handles.reducedData.eigenValues]=...
           cmdscale(D);
       
        %normalizes eigen values
        handles.reducedData.normalizedEigen=handles.reducedData.eigenValues...
            /sum(abs(handles.reducedData.eigenValues)); 

        %clears eigenValues - if variance is 0.001% (10PPM) or less, it is removed
        preClearSize=length(handles.reducedData.normalizedEigen);       
        handles.reducedData.normalizedEigen(abs(handles.reducedData.normalizedEigen)<mEV)=[];
        removedEigen =preClearSize-length(handles.reducedData.normalizedEigen);
        msgbox([{[num2str(removedEigen) ' EigenValues where Removed !']};{''};{['Each value was less than ' num2str(100*mEV) '%']}],'Info','help');
         
        %generates header for plot window
        handles.reducedData.plotHeader = ['Cmd - ' dissMethod]; 
       
        %generates new log
        handles.reducedData.textToLog = [get(handles.raw_log,'string');...
           {['Normalization:' str1{val1}]};{' '};{['Dissimilarities Metric: '...
           dissMethod]};{str3{val3}}];
       
       %updates dim_red_log box
       set(handles.dim_red_log,'String',handles.reducedData.textToLog);
       
       %sets visibilities for panels, and reset values in Analysis Section    
       set(handles.dim_red_panel,'visible','on');
       set(handles.cmd_analysis_panel,'visible','on');
       set(handles.nr_an_dim_edit,'String','3');
       set(handles.perc_var_nr,'String',num2str(roundn(100*sum(...
           handles.reducedData.normalizedEigen(1:3)),-2)));
       set(handles.max_an_dim_nr,'String',num2str(length(...
           handles.reducedData.normalizedEigen)));
       
       %Clustering: set number of dimensions selection visible
       set(handles.clust_dim,'enable','on');
       set([handles.dim_text],'enable','on');
       
    case 'Multi Dimensional Scaling' 
        
        %
        % calculate dissimilarity matrix and Text for figure and raw_log, 
        % taking atention for minkowski special case
        %
        if (val2==6)
            mink_val = get(handles.diss_mink_pp,'Value');
            D=pdist(handles.current_data,'minkowski',mink_val);
            dissMethod=[str2{val2} ' - ' num2str(mink_val)];
        else
            D=pdist(handles.current_data,str2{val2});
            dissMethod=str2{val2};
        end
        
        %
        %reads values from objects that allow options
        %
        mds_val = get(handles.mds_nr_dim_pp,'Value')+1;%reads number of mds dimensions
        crit_val = get(handles.criterion_pp,'Value');
        crit_str = get(handles.criterion_pp,'String');
        start_val = get(handles.mds_start_pp,'Value');
        start_str = get(handles.mds_start_pp,'String');
        disp_val = get(handles.mds_disp_pp,'Value');
        disp_str = get(handles.mds_disp_pp,'String');
        pdist_met_val = get(handles.mds_metric_pp,'Value');
        pdist_met_str = get(handles.mds_metric_pp,'String');
        pdist_v=pdist_met_str{pdist_met_val};
        
        % ===================================================
        % MDS optimization metric parameter
        % DO NOT CHANGE - NEEDED TO Classe_mdscale 
        if(strcmp(pdist_v,'Minkowski'))
            mds_mink_val = get(handles.mds_mink_pp,'Value');
            mds_mink_str = get(handles.mds_mink_pp,'String');
            mds_mink_v=mds_mink_str{mds_mink_val};       
            pdist_log=[pdist_v ' ' mds_mink_v];
            pdist_v=strcat(pdist_v,mds_mink_v);
        else
            pdist_log=pdist_v;
        end
       % ====================================================
             
       % gets criterion form the text in criterion PopUp
       cr=crit_str{crit_val};
       cr(1:8)=[];
       if(crit_val<=2)
           cr(1:4)=[];
       end
       
       % gets parameters
       st=start_str{start_val}; 
       maxIter = str2double(get(handles.max_iter_edit,'String'));
       tol_fun = str2double(get(handles.tolfun_edit,'String'));
       tol_x = str2double(get(handles.tolx_edit,'String'));      
       
       %calculates MDS
       handles.reducedData.dataMatrix=Classe_mdscale(D,mds_val,'criterion',cr,'start',st,'options',...
           statset('display',disp_str{disp_val},'maxIter',maxIter,...
           'TolFun',tol_fun,'Tolx',tol_x),'pdist_metric',pdist_v);
       
       %generates Header
       handles.reducedData.plotHeader=['MDS ' num2str(mds_val) ' Dim.;  ' dissMethod]; %generates plot window header
              
       %generates new log text
       handles.reducedData.textToLog = [get(handles.raw_log,'string');...
           {['Normalization: ' str1{val1}]};{' '};{['Dissimilarities Metric: ' dissMethod]};...
           {[str3{val3} ' - ' num2str(mds_val) ' Dim.']};{['Criterion: ' cr]};...
           {['Start:' st]};{['Nr Iterations: ' num2str(maxIter)]};{['Stress Criterion Tolerance: '...
           num2str(tol_fun)]};{['Step Size Tolerance: ' num2str(tol_x)]};{['MDS Metric: ' pdist_log]}];
       
       %updates dim_red_log box
       set(handles.dim_red_log,'String',handles.reducedData.textToLog);
       
       %updates objects visibility
       set(handles.cmd_analysis_panel,'visible','off');
       set(handles.dim_red_panel,'visible','on');
       
       %Clustering:
       set(handles.clust_dim,'enable','off');
       set([handles.dim_text],'enable','off');
  
    case 'PCA'
        %calculates PCA
        [coefs, handles.reducedData.dataMatrix, handles.reducedData.eigenValues, t2] = princomp(handles.current_data);
        
        %calculates normalized EigenValues
        handles.reducedData.normalizedEigen=handles.reducedData.eigenValues...
            /sum(abs(handles.reducedData.eigenValues)); 
        
        %clears eigenValues - if variance is 0.01% or less, it is removed
        preClearSize=length(handles.reducedData.normalizedEigen);
        handles.reducedData.normalizedEigen(abs(handles.reducedData.normalizedEigen)<mEV)=[];
        removedEigen =preClearSize-length(handles.reducedData.normalizedEigen);
        msgbox([{[num2str(removedEigen) ' EigenValues where Removed !']};{['Value was less than ' num2str(100*mEV) '%']}]);
        
        % Defines Header for plots
        handles.reducedData.plotHeader='PCA';
       
        %generates new log
        handles.reducedData.textToLog = char([get(handles.raw_log,'string');...
            {['Normalization: ' str1{val1}]};{' '};{str3{val3}}]);
       
        %updates dim_red_log box
        set(handles.dim_red_log,'String',handles.reducedData.textToLog);
        
        %Biplots PCA
        figure('Name','PCA','numbertitle','off')
            subplot(2,2,1)
                plot3(handles.reducedData.dataMatrix(:,1),handles.reducedData.dataMatrix(:,2),handles.reducedData.dataMatrix(:,3),'x');
                grid on
                title('PCA')
            subplot(2,2,2)
                plot3(handles.reducedData.dataMatrix(:,1),handles.reducedData.dataMatrix(:,2),handles.reducedData.dataMatrix(:,3),'x');
                grid on
                axis equal
                title('PCA - equal axis')
        subplot(2,2,3)
    %        figure('Name','PCA-Biplot','numbertitle','off')
            biplot(coefs(:,1:3),'scores',handles.reducedData.dataMatrix(:,1:3),'varlabels',handles.labels.varNames)
            grid on
            title('Biplot')
        subplot(2,2,4)
            pareto(handles.reducedData.normalizedEigen);
            xlabel('Principal Component');
            ylabel('Variance Explainde (%)');
            grid on
%        figure('name','Variables Infuence Analysis','numbertitle','off')
%        [Y,e]=cmdscale(pdist(handles.current_data'));
%        biplot(Y(:,1:3),'varlabels',handles.name_vars)
%        Y=scores;
       
       %sets visibilities for panels, and reset values in Analysis Section    
       set(handles.dim_red_panel,'visible','on');
       set(handles.cmd_analysis_panel,'visible','on');
       set(handles.nr_an_dim_edit,'String','3');
       set(handles.perc_var_nr,'String',num2str(roundn(100*sum(...
           handles.reducedData.normalizedEigen(1:3)),-2)));
       set(handles.max_an_dim_nr,'String',num2str(length(...
           handles.reducedData.normalizedEigen)));

       %Clustering: set number of dimensions selection visible
       set(handles.clust_dim,'enable','on');
       set([handles.dim_text],'enable','on');

       
end

set(handles.raw_log_panel,'visible','on'); %shows plot panel
set(handles.save_red,'enable','on'); %shows plot panel

%-------------------------------------------------------------------
% Several Methods to enable Clustering Methods

    %show panel with Hierarchical parameters if all the others are off and SOM is visible (happens by default):
    vis1 = get(handles.panel_hierar,'Visible');
    vis2 = get(handles.panel_kmeans,'Visible');
    vis3 = get(handles.panel_cmeans,'Visible');
    vis4 = get(handles.panel_sub,'Visible');
    vis5 = get(handles.panel_dignet,'Visible');
    vis6 = get(handles.par6_1,'Enable');    %if off, hide SOM panel (first press on this button)
    if strcmp(vis1,'off')==1 && strcmp(vis2,'off')==1 && strcmp(vis3,'off')==1 && strcmp(vis4,'off')==1 && strcmp(vis5,'off')==1 && strcmp(vis6,'off')==1
        set(handles.panel_som,'visible','off');
        set(handles.panel_hierar,'visible','on');  %if all panels are invisible, turns hierarchical visible
        set(handles.clust_alg,'value',1.0);
        set(handles.create_clusters,'String','Calculate & Plot');
    end
    % Add text to clustering info
    set(handles.panel_clust_info,'visible','on');
    str=get(handles.list_clust_info,'String');
    set(handles.list_clust_info,'String',strvcat(str,['Reduced data is ready for clustering.']));
    % Enable all clustering selection
    set([handles.clust_alg handles.par6_1],'Enable','on');
    set([handles.par6_1],'Value',1);
    % Allows Saving
    set(handles.save_red,'enable','on');
    % Disable Clustering Save (prevent mistakes)
    set([handles.rad_mat handles.rad_xls handles.rad_work handles.save],'Enable','off');
    
%-------------------------------------------------------------------

%saves handles
guidata(hObject, handles);
toc
%% - MDS Parameters
% --- mds_nr_dim_pp --- matlab generated code
function mds_nr_dim_pp_Callback(hObject, eventdata, handles)
function mds_nr_dim_pp_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end

% --- Executes on selection change in mds_metric_pp.
function mds_metric_pp_Callback(hObject, eventdata, handles)
%in Minkowski metric, shows popupmenu for factor choice
    val = get(hObject,'Value');
    if(val~=6)
        set(handles.mds_mink_pp,'visible','off');
    else 
        set(handles.mds_mink_pp,'visible','on');
    end
% --- Executes during object creation, after setting all properties.
function mds_metric_pp_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end

% --- dim_red_log --- matlab autogenerated code
function dim_red_log_Callback(hObject, eventdata, handles)
function dim_red_log_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
% --- criterion_pp --- matlab autogenerated code
function criterion_pp_Callback(hObject, eventdata, handles)
function criterion_pp_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
% --- mds_mink_pp --- matlab autogenerated code
function mds_mink_pp_Callback(hObject, eventdata, handles)
function mds_mink_pp_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
% --- mds_disp_pp --- matlab autogenerated code
function mds_disp_pp_Callback(hObject, eventdata, handles)
function mds_disp_pp_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
% --- tolfun_edit --- matlab autogenerated code
function tolfun_edit_Callback(hObject, eventdata, handles)
function tolfun_edit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
% --- tolx_edit --- matlab autogenerated code
function tolx_edit_Callback(hObject, eventdata, handles)
function tolx_edit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
% --- max_iter_edit --- matlab autogenerated code
function max_iter_edit_Callback(hObject, eventdata, handles)
function max_iter_edit_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
% --- mds_start_pp --- matlab autogenerated code
function mds_start_pp_Callback(hObject, eventdata, handles)
function mds_start_pp_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end    


%% - Eigen Values Based Analysis



% --- Executes on button press in CMD_analysis_button. (ANALYSE)
function CMD_analysis_button_Callback(hObject, eventdata, handles)
% hObject    handle to CMD_analysis_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    n= str2double(get(handles.nr_an_dim_edit,'String')); % number of dimensions
    p= str2double(get(handles.perc_out_edit,'String')); % percentage of outliers
    
    %calculation of Eigen
    distance = eigenValuesBasedAnalysis(handles.reducedData.dataMatrix,...
        handles.reducedData.normalizedEigen,n);

    % percentil calcule
    perc=prctile(distance,(100-p));
    %outliers detection
    indices=find(distance>perc)';
    %mean line generation
    meanLine=mean(distance)*ones(size(distance));
    %percentil line generation
    percLine=perc*ones(size(distance)); 
    

    % Plot Analysis
    figure('Name',['Absolute Distance \  ' num2str(n) ' Dimensions \  ' num2str(p) '% Outliers'],'NumberTitle','off');
        plot(percLine,'color','red');
        grid on;
        hold on
        plot(meanLine,'color','green');
        plot(distance,'-x');
        legend([num2str(100-p) '% events'],'mean value','Abs. Distances');
        hold off
    %labeling routine
        dcm_obj = datacursormode;
        set(dcm_obj,'DisplayStyle','datatip','SnapToDataVertex','on',...
            'Enable','on','UpdateFcn',{@myupdatefcn,handles.labels})

    %write outliers to a string
    text=get(handles.raw_log,'String');
    text=[text; {' '};{' '};{'Absolute Distance'};...
    {['Number of analysed dimension: ' num2str(n)]};...
    {['Amount of explained Variance: ' num2str(sum(handles.reducedData.normalizedEigen(1:n)))]};...
    {['Percentage of Outliers: ' num2str(p)];' '}];
    
    text=[text; handles.labels.Label_1(indices)'];
        
    % Export text to outliers_gui
    outliers_window(text);

% --- Executes on button press in nlPCA_button.
function nlPCA_button_Callback(hObject, eventdata, handles)
    % hObject    handle to nlPCA_button (see GCBO)
    % eventdata  reserved - to be defined in a future version of MATLAB
    % handles    structure with handles and user data (see GUIDATA)
        
        for i=1 : length(handles.reducedData.normalizedEigen)
            if (sum(handles.reducedData.normalizedEigen(1:i))>0.995)
                break;
            end
        end
        disp(['Number of analysed dimentions- ' num2str(i)]);
        %================================================
        temp.reduced_info=get(handles.dim_red_log,'string');
        nlpcaGui(handles.reducedData.dataMatrix,handles.reducedData.textToLog,handles.reducedData.plotHeader,handles.labels);

% --- Executes on button press in pareto_button.
function pareto_button_Callback(hObject, eventdata, handles)
% hObject    handle to pareto_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
       
       %calculate and plot "pareto" function
       bars=handles.reducedData.normalizedEigen(1:min(end,5));
       comulativeLine=cumsum(bars);
       figure('Name','Cmd Eigenvalues','NumberTitle','off')
            subplot(1,2,1) 
               bar(bars);
               hold on;
               plot(comulativeLine);
               legend('eingenvalues',{'Comulative','eingenvalues'},'Location','East');
               grid on;
               title('Pareto')
               xlabel('Principal Component');
               ylabel('EigenValues');        
               hold off;
            subplot(1,2,2)         
               plot(handles.reducedData.normalizedEigen,'-x');
               xlabel('Principal Component');
               ylabel('EigenValues');
               grid on
               
function nr_an_dim_edit_Callback(hObject, eventdata, handles)
% hObject    handle to nr_an_dim_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% validates number of dimensions in analyse panel, and updates the
% "percentage of explained variance" value.
    n= str2double(get(hObject,'String')); % string in 
    nmax=str2double(get(handles.max_an_dim_nr,'String'));
    if(n<1)
        n=1;
    elseif(n>nmax)
        n=nmax;
    end
    set(handles.nr_an_dim_edit,'String',num2str(n));
    set(handles.perc_var_nr,'String',num2str(roundn(100*sum(handles.reducedData.normalizedEigen(1:n)),-2)));
% Hints: get(hObject,'String') returns contents of nr_an_dim_edit as text
%        str2double(get(hObject,'String')) returns contents of nr_an_dim_edit as a double


% --- Executes during object creation, after setting all properties.
function nr_an_dim_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nr_an_dim_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function perc_out_edit_Callback(hObject, eventdata, handles)
% hObject    handle to perc_out_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%validates choice of percentil of outliers to detect
n=str2double(get(handles.perc_out_edit,'String'));
if(n<0)
    set(handles.perc_out_edit,'String','0');
elseif(n>100)
    set(handles.perc_out_edit,'String','100');
end

% Hints: get(hObject,'String') returns contents of perc_out_edit as text
%        str2double(get(hObject,'String')) returns contents of perc_out_edit as a double


% --- Executes during object creation, after setting all properties.
function perc_out_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to perc_out_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



%% - Plot

% --- Executes on button press in dim_red_plot_button. (PLOT)
function dim_red_plot_button_Callback(hObject, eventdata, handles)
% hObject    handle to dim_red_plot_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    f1=figure('Name',handles.reducedData.plotHeader,'NumberTitle','off'); %defines figure headline
    %gets plot symbol
    str=get(handles.p_symb_pp,'String');
    val = get(handles.p_symb_pp,'Value');
    %gets axis equals
    ea=get(handles.EqAxisOp,'Value');
    % Plots for 2 ou 3 Dimentions
    c=size(handles.reducedData.dataMatrix,2);
    if c>2
        plot3(handles.reducedData.dataMatrix(:,1),handles.reducedData.dataMatrix(:,2),handles.reducedData.dataMatrix(:,3),str{val});
        zlabel('Dimension 3');
    else
        plot(handles.reducedData.dataMatrix(:,1),handles.reducedData.dataMatrix(:,2),str{val});
    end
    grid on;
    xlabel('Dimension 1');
    ylabel('Dimension 2');

    %plot with or without axis equal
    if ea==1
        axis equal
    end
    
    %Define point labeling routine
    dcm_obj = datacursormode(f1);
    set(dcm_obj,'DisplayStyle','datatip','SnapToDataVertex','on',...
        'Enable','on','UpdateFcn',{@myupdatefcn,handles.labels})

% --- p_symb_pp --- Matlab automatic generated code
function p_symb_pp_Callback(hObject, eventdata, handles)
function p_symb_pp_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end
% --- raw_log --- matlab generated code
function raw_log_Callback(hObject, eventdata, handles)
function raw_log_CreateFcn(hObject, eventdata, handles)
    if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
        set(hObject,'BackgroundColor','white');
    end

%% - Load & Save

% --- Executes on button press in save_red.
function save_red_Callback(hObject, eventdata, handles)
% hObject    handle to save_red (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    % Save dialog
    [a,b]=uiputfile('*.mat','Save Reduced Matrix and Clustering Results');

    if isequal([a,b],[0,0])
        return
    else
        c=strcat(b,a);

        % Get structures to save
        if isfield(handles,'rawData')
            rawData = handles.rawData;
        end
        labels = handles.labels;
        reducedData = handles.reducedData;

        % Save all structures:
        if isfield(handles,'rawData')
            save (c,'rawData','labels','reducedData')
        else
            save (c,'labels','reducedData')
        end

        % Update Info
        str=get(handles.list_clust_info,'String');
        set(handles.list_clust_info,'String',strvcat(str,['Results saved to MAT-File: ' a]));
    end


% --- Executes on button press in load_file.
function load_file_Callback(hObject, eventdata, handles)
% hObject    handle to load_file (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[filename, pathname] = uigetfile( ...
{'*.mat', 'MAT-Files (*.mat)'; ...
'*.*','All Files (*.*)'}, ...
'Select Reduced Matrix to Load');

% Invisible objects by default:
set(handles.title_arr,'visible','off');
set(handles.select_arr,'visible','off');

% If "Cancel" is selected then return
if isequal([filename,pathname],[0,0])
    return
    % Otherwise construct the fullfilename and load the selected array in MAT-File
else
    file = fullfile(pathname,filename);
    handles.fil=filename;   %neaded to write in log
    handles.loadStructure=open(file);
    names = fieldnames(handles.loadStructure);  %get list off arrays in mat-file
    sz = length(names);
    loadOK = 0;
    % Find recognizable structures
    aux=find(strcmp(names,'reducedData'));
    if aux>0
        % Load structures
        handles.reducedData = handles.loadStructure.reducedData;
        handles.labels = handles.loadStructure.labels;
        aux2=find(strcmp(names,'rawData'));
        % If rawData doesn't exist, remove it from handles
        if aux2>0
            handles.rawData = handles.loadStructure.rawData;
        else
            if isfield(handles,'rawData')
                handles = rmfield(handles,'rawData');
            end
        end
        
        % If loaded data from CMD, enable CMD Analisys
        redMethod=handles.reducedData.plotHeader(1:3);
        if ~strcmpi(redMethod,'MDS')
            set(handles.cmd_analysis_panel,'visible','on');
            set(handles.nr_an_dim_edit,'String','3');
            set(handles.max_an_dim_nr,'String',num2str(size(handles.reducedData.dataMatrix,2)));
            set([handles.clust_dim handles.dim_text ],'enable','on');
        end
        
        loadOK = 1;
    else
        % Load first variable by default
        data = handles.loadStructure.(names{1});
        name_array = names{1};

        % Check if loaded matrix is valid
        if isa(data, 'numeric') && size(data,2)>1
            % Clear structures
            if isfield(handles,'rawData'); handles = rmfield(handles,'rawData'); end
            if isfield(handles,'labels'); handles = rmfield(handles,'labels'); end
            if isfield(handles,'reducedData'); handles = rmfield(handles,'reducedData'); end

            % Create new structures
            handles.reducedData.dataMatrix = data;
            handles.reducedData.plotHeader = 'Loaded data';
            handles.reducedData.textToLog = {['MAT-File: ' filename]; ['Array: ' name_array]; ...
                                             ['Dimensions: ' num2str(size(data,2))]; ...
                                             ['Number of Rows: ' num2str(size(data,1))]};
            handles.labels = decodeExcelData(data,[]);

            % Disable CMD analisys
            set(handles.cmd_analysis_panel,'visible','off');
            
            % If dimension is upper to 2, let choose number of dimensions
            if size(data,2)>2
                set([handles.dim_text handles.clust_dim],'enable','on');
            elseif size(data,2)==2
                set([handles.dim_text handles.clust_dim],'enable','off');
            end

            loadOK = 1;
        else
            errordlg('Loaded Matrix is not valid','Incorrect Selection','modal')
            return
        end

        % Check number of variables in MAT-File
        if sz>1
            set(handles.title_arr,'visible','on');
            set(handles.select_arr,'visible','on');
            set(handles.select_arr,'String',names);
        end
    end

    if loadOK == 1
        % Show loaded data information
        set(handles.dim_red_log,'String',strvcat('LOADED DATA INFO:',char(handles.reducedData.textToLog), ' '));

        % Set clustering panels visible
        set(handles.dim_red_panel,'visible','on');      %shows plot panel
        set([handles.panel_alg handles.panel_create_clusters],'visible','on');          %to set clustering method panel visible

        % Show the panel with Hierarchical parameters when all the others are off:
        vis1 = get(handles.panel_hierar,'Visible');
        vis2 = get(handles.panel_kmeans,'Visible');
        vis3 = get(handles.panel_cmeans,'Visible');
        vis4 = get(handles.panel_sub,'Visible');
        vis5 = get(handles.panel_dignet,'Visible');
        vis6 = get(handles.panel_som,'Visible');
        if strcmp(vis1,'off')==1 && strcmp(vis2,'off')==1 && strcmp(vis3,'off')==1 && strcmp(vis4,'off')==1 && strcmp(vis5,'off')==1 && strcmp(vis6,'off')==1
            set(handles.panel_hierar,'visible','on');  %if all panels are invisible, turns hierarchical visible
        end

        % Add text to clustering info
        set(handles.panel_clust_info,'visible','on');
        str=get(handles.list_clust_info,'String');
        set(handles.list_clust_info,'String',strvcat(str,['Loaded data is ready for clustering.']));

        % Enable all clustering selection
        set([handles.clust_alg],'Enable','on');
        % Exception for SOM
        set([handles.par6_1],'Value',1.0);
        set([handles.par6_1],'Enable','off');
        % Disable Clustering Save (prevent mistakes)
        set([handles.rad_mat handles.rad_xls handles.rad_work handles.save],'Enable','off');

        % Disable open from Excel
        set([handles.excel_sheet_list,...
            handles.start_txt...
            handles.end_txt...
            handles.start_edit...
            handles.read_raw_button...
            handles.end_edit...
            handles.plot_clust...
            handles.select_exel_file_button],'enable','off');
        set(handles.excel_sheet_list,'string','');

        % Save handles
        guidata(hObject, handles)   %saves handles
    end

end

% --- Executes on selection change in select_arr.
function select_arr_Callback(hObject, eventdata, handles)
% hObject    handle to select_arr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns select_arr contents as cell array
%        contents{get(hObject,'Value')} returns selected item from select_arr

str = get(hObject,'String');
val = get(hObject,'Value');

% Get selected variable
data=handles.loadStructure.(str{val});
if isa(data,'numeric') && size(data,2)>1
    % Clear structures
    if isfield(handles,'rawData'); handles = rmfield(handles,'rawData'); end
    if isfield(handles,'labels'); handles = rmfield(handles,'labels'); end
    if isfield(handles,'reducedData'); handles = rmfield(handles,'reducedData'); end

    % Create new structures
    handles.reducedData.dataMatrix = data;
    handles.reducedData.plotHeader = 'Loaded data';
    handles.reducedData.textToLog = {['MAT-File: ' handles.fil]; ['Array: ' str{val}]; ...
        ['Dimensions: ' num2str(size(data,2))]; ...
        ['Number of Rows: ' num2str(size(data,1))]};
    handles.labels = decodeExcelData(data,[]);

    % Disable CMD analisys
    set(handles.cmd_analysis_panel,'visible','off');

    % If dimension is upper to 2, let choose number of dimensions
    if size(data,2)>2
        set([handles.dim_text handles.clust_dim],'enable','on');
    elseif size(data,2)==2
        set([handles.dim_text handles.clust_dim],'enable','off');
    end
    
    % Show loaded data information
    set(handles.dim_red_log,'String',strvcat('LOADED DATA INFO:',char(handles.reducedData.textToLog), ' '));

    % Set clustering panels visible
    set(handles.dim_red_panel,'visible','on');      %shows plot panel
    set([handles.panel_alg handles.panel_create_clusters],'visible','on');          %to set clustering method panel visible

    % Show the panel with Hierarchical parameters when all the others are off:
    vis1 = get(handles.panel_hierar,'Visible');
    vis2 = get(handles.panel_kmeans,'Visible');
    vis3 = get(handles.panel_cmeans,'Visible');
    vis4 = get(handles.panel_sub,'Visible');
    vis5 = get(handles.panel_dignet,'Visible');
    vis6 = get(handles.panel_som,'Visible');
    if strcmp(vis1,'off')==1 && strcmp(vis2,'off')==1 && strcmp(vis3,'off')==1 && strcmp(vis4,'off')==1 && strcmp(vis5,'off')==1 && strcmp(vis6,'off')==1
        set(handles.panel_hierar,'visible','on');  %if all panels are invisible, turns hierarchical visible
    end

    % Add text to clustering info
    set(handles.panel_clust_info,'visible','on');
    str=get(handles.list_clust_info,'String');
    set(handles.list_clust_info,'String',strvcat(str,['Loaded data is ready for clustering.']));

    % Enable all clustering selection
    set([handles.clust_alg],'Enable','on');
    % Exception for SOM
    set([handles.par6_1],'Value',1.0);
    set([handles.par6_1],'Enable','off');
    % Disable Clustering Save (prevent mistakes)
    set([handles.rad_mat handles.rad_xls handles.rad_work handles.save],'Enable','off');

    % Disable open from Excel
    set([handles.excel_sheet_list,...
        handles.start_txt...
        handles.end_txt...
        handles.start_edit...
        handles.read_raw_button...
        handles.end_edit...
        handles.plot_clust...
        handles.select_exel_file_button],'enable','off');
    set(handles.excel_sheet_list,'string','');

    % Save handles
    guidata(hObject, handles)   %saves handles

else
    errordlg('Loaded Matrix is not valid','Incorrect Selection','modal')
    return
end

% --- Executes during object creation, after setting all properties.
function select_arr_CreateFcn(hObject, eventdata, handles)
% hObject    handle to select_arr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end    

%% CLUSTERING METHODS

%% - Load Clustered Data

% --- Executes on button press in load_clust.
function load_clust_Callback(hObject, eventdata, handles)
% hObject    handle to load_clust (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[filename, pathname] = uigetfile( ...
{'*.mat', 'MAT-Files (*.mat)'; ...
'*.*','All Files (*.*)'}, ...
'Select Reduced Matrix to Load');

% If "Cancel" is selected then return
if isequal([filename,pathname],[0,0])
    return
% Otherwise construct the fullfilename and load MAT-File
else
    file = fullfile(pathname,filename);
    handles.clust_load.file=filename;       %neaded to write info
    struc=open(file);
    names = fieldnames(struc);  %get list off arrays in mat-file

    % it must contain two variables at minimum
    if length(names)<2
        errordlg('MAT-File must contain reduced data and clustering structures','Incorrect Selection','modal')
    else
        % run all variable names and set them
        found_data=0;           %control
        found_cluster=0;        %control
        found_labels=0;         %control
        for i=1:size(names,1)
            if strcmp(names{i},'reducedData')==1
                handles.clust_load.reducedData=struc.(names{i});
                found_data=1;
            elseif strcmp(names{i},'clusteringData')==1
                handles.clust_load.clusteringData=struc.(names{i});
                found_cluster=1;
            elseif strcmp(names{i},'labels')==1
                handles.clust_load.labels=struc.(names{i});
                found_labels=1;
            end
        end
        % if data and cluster were found, enable plot
        if found_data==1 && found_cluster==1
            set(handles.plot_clust,'Enable','on')
            set(handles.panel_clust_info,'Visible','on')
            str=get(handles.list_clust_info,'String');
            set(handles.list_clust_info,'String',strvcat(str,['Cluster data from file ' filename ' is ready for plotting.']));
            % Disable Clustering Save (prevent mistakes)
            set([handles.rad_mat handles.rad_xls handles.rad_work handles.save],'Enable','off');
            
            % Generate labels if not found
            if found_labels==0
                handles.clust_load.labels = decodeExcelData(handles.clust_load.reducedData.dataMatrix,[]);
            end
            
            % Save handles
            guidata(hObject, handles);
        else
            % Display error message and do not save handles
            errordlg('MAT-File must contain data and cluster arrays','Incorrect Selection','modal')
        end
    end
end


% --- Executes on button press in plot_clust.
function plot_clust_Callback(hObject, eventdata, handles)
% hObject    handle to plot_clust (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Plot clusters
PlotClusters(handles.clust_load.reducedData.dataMatrix, handles.clust_load.clusteringData.clusters,...
    ['Clustering Data from file: ' char(handles.clust_load.file)], ...
    [handles.clust_load.clusteringData.method ' Clustering. ' num2str(handles.clust_load.clusteringData.parameters.nrClusters) ' clusters.'])

% Activate datacursor
mylabels(handles.clust_load.reducedData.dataMatrix, handles.clust_load.labels);

% nr=max(handles.clust_load.cluster);
% figure('name',['Clustering Data from file: ' char(handles.clust_load.file)])
% % Routines to alternate colors and symbols ------------------------------
% simb = {'+','o','*','<','.','x','s','d','v','>','p','h','^'};
% cm=colormap;
% j=1;
% k=1;
% l=1;
% if nr<64
%     k=floor(64/nr);
% end
% leg='Cluster 1';
% %------------------------------------------------------------------------
% for i = 1:nr
%     if i>1
%         leg=strvcat(leg, ['Cluster ' num2str(i)]);     %add legend
%     end
%     
%     if j>64; j=1; end       %repeat color cycle
%     if l>13; l=1; end       %repeat symbol cycle
%     
%     clust = find(handles.clust_load.cluster==i);     %return each cluster indexes
%     if size(handles.clust_load.data,2)>2
%         plot3(handles.clust_load.data(clust,1),handles.clust_load.data(clust,2),handles.clust_load.data(clust,3),simb{l},'color',cm(j,:));
%     elseif size(handles.clust_load.data,2)==2
%         plot(handles.clust_load.data(clust,1),handles.clust_load.data(clust,2),simb{l},'color',cm(j,:));
%     end
%     j=j+k;
%     l=l+1;
%     hold on
% end
% xlabel('1st Dimension'); ylabel('2nd Dimension'); zlabel('3rd Dimension');
% grid on
% legend(leg)
% title('Clustering Data')
% 
% %-------------------------------------------------------------------------
% if handles.clust_load.hasLabel1==1
%     %Rotines to activate datacursor:
%     if size(handles.clust_load.data,2)==2
%         plot(handles.clust_load.data(:,1),handles.clust_load.data(:,2),'.','markersize',.5,'color','w');    %white plot
%     else
%         plot3(handles.clust_load.data(:,1),handles.clust_load.data(:,2),handles.clust_load.data(:,3),'.','markersize',.5,'color','w');    %white plot
%     end
%     dcm_obj = datacursormode;
%     set(dcm_obj,'DisplayStyle','datatip','SnapToDataVertex','on',...
%         'Enable','on','UpdateFcn',{@myupdatefcn,handles.clust_load.label1,handles.clust_load.hasLabel2,handles.clust_load.label2})
% end
% %-------------------------------------------------------------------------

%% - Clustering Method Selection

% --- Executes on selection change in clust_alg.
function clust_alg_Callback(hObject, eventdata, handles)
% hObject    handle to clust_alg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns clust_alg contents as cell array
%        contents{get(hObject,'Value')} returns selected item from clust_alg

% Set default options
set(handles.panel_create_clusters,'visible','on');
set(handles.create_clusters,'String','Calculate & Plot');
set(handles.plot_text,'enable','on');
set(handles.centers,'enable','on');

% Determine wich parameters panel to show
str = get(hObject,'String');
val = get(hObject,'Value');

switch str{val};
case 'Hierarchical'
    set(handles.panel_hierar,'visible','on');
    set(handles.panel_kmeans,'visible','off');
    set(handles.panel_cmeans,'visible','off');
    set(handles.panel_sub,'visible','off');
    set(handles.panel_dignet,'visible','off');
    set(handles.panel_som,'visible','off');
    set(handles.plot_text,'enable','off');
    set(handles.centers,'enable','off');
case 'K-Means'
    set(handles.panel_hierar,'visible','off');
    set(handles.panel_kmeans,'visible','on');
    set(handles.panel_cmeans,'visible','off');
    set(handles.panel_sub,'visible','off');
    set(handles.panel_dignet,'visible','off');
    set(handles.panel_som,'visible','off');
case 'Fuzzy C-Means'
    set(handles.panel_hierar,'visible','off');
    set(handles.panel_kmeans,'visible','off');
    set(handles.panel_cmeans,'visible','on');
    set(handles.panel_sub,'visible','off');
    set(handles.panel_dignet,'visible','off');
    set(handles.panel_som,'visible','off');
case 'Fuzzy Subtractive'
    set(handles.panel_hierar,'visible','off');
    set(handles.panel_kmeans,'visible','off');
    set(handles.panel_cmeans,'visible','off');
    set(handles.panel_sub,'visible','on');
    set(handles.panel_dignet,'visible','off');
    set(handles.panel_som,'visible','off');
case 'Dignet'
    set(handles.panel_hierar,'visible','off');
    set(handles.panel_kmeans,'visible','off');
    set(handles.panel_cmeans,'visible','off');
    set(handles.panel_sub,'visible','off');
    set(handles.panel_dignet,'visible','on');
    set(handles.panel_som,'visible','off');
case 'SOM'
    set(handles.panel_hierar,'visible','off');
    set(handles.panel_kmeans,'visible','off');
    set(handles.panel_cmeans,'visible','off');
    set(handles.panel_sub,'visible','off');
    set(handles.panel_dignet,'visible','off');
    set(handles.panel_som,'visible','on');
    set(handles.plot_text,'enable','off');
    set(handles.centers,'enable','off');
    sel=get(handles.par6_0,'Value');
    if sel==1
        set(handles.create_clusters,'String','Open SOM Guide');
    elseif sel==2
        set(handles.create_clusters,'String','Open RecSOM Guide');
    end
end

% --- Executes during object creation, after setting all properties.
function clust_alg_CreateFcn(hObject, eventdata, handles)
% hObject    handle to clust_alg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% - Parameter Panels

% Parameters in panel_hierar

% --- Executes during object creation, after setting all properties.
function par1_1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par1_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function par1_2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par1_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function par1_3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par1_3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function par1_4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par1_4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Parameters in panel_kmeans

% --- Executes during object creation, after setting all properties.
function par2_1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par2_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function par2_2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par2_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function par2_3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par2_3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function par2_4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par2_4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Parameters in panel_cmeans

% --- Executes during object creation, after setting all properties.
function par3_1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par3_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function par3_2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par3_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function par3_3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par3_3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function par3_4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par3_4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Parameters in panel_sub

% --- Executes during object creation, after setting all properties.
function par4_1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par4_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function par4_2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par4_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function par4_3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par4_3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function par4_4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par4_4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Parameters in panel_dignet

% --- Executes during object creation, after setting all properties.
function par5_1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par5_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function par5_2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par5_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Parameters in panel_som

% --- Executes on selection change in par6_0.
function par6_0_Callback(hObject, eventdata, handles)
% hObject    handle to par6_0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns par6_0 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from par6_0

val=get(handles.par6_0,'Value');
if val==1
    set(handles.create_clusters,'String','Open SOM Guide');
elseif val==2
    set(handles.create_clusters,'String','Open RecSOM Guide');
end

% --- Executes during object creation, after setting all properties.
function par6_0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par6_0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function par6_1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to par6_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% - Create Clusters Panel

% --- Executes during object creation, after setting all properties.
function clust_dim_CreateFcn(hObject, eventdata, handles)
% hObject    handle to clust_dim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in create_clusters.
function create_clusters_Callback(hObject, eventdata, handles)
% hObject    handle to create_clusters (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Format reduced matrix for clustering (if it exists)
if isfield(handles,'reducedData')
    if isfield(handles.reducedData,'dataMatrix')
        data = handles.reducedData.dataMatrix;          %get matrix from dimension reduction
        meth = handles.reducedData.plotHeader(1:3);     %reduction method string
        if (strcmp(upper(meth),'CMD') || strcmp(upper(meth),'PCA'))   %if CMD or PCA Reduction
            dim = get(handles.clust_dim,'Value');       %get nr of dimensions (1:3D; 2:2D)
            if dim==2
                data=data(:,1:2);
            else
                data=data(:,1:3);
            end
        else                                            %if MDS Reduction
            if size(data,2)>2
                data=data(:,1:3);                       %use 3 dimensions at most
            end
        end
    end
end

% Initialize common variables
doClustering=1;     %after all methods but SOM
info='';            %for all methods
moreInfo=0;         %for not specified number of clusters
itensSave='on';     %for all methods but SOM
allOK=0;            %check errors
centers = get(handles.centers,'Value');

str = get(handles.clust_alg,'String'); val = get(handles.clust_alg,'Value');
method = str{val};

% Switch clustering method
switch method;
    case 'Hierarchical'
        str2 = get(handles.par1_2,'String'); val2 = get(handles.par1_2,'Value');
        str3 = get(handles.par1_3,'String'); val3 = get(handles.par1_3,'Value');
        par1 = str2double(get(handles.par1_1,'String'));    % convert nr of clusters to integer
        par2 = str2{val2};                                  % distance metric
        par3 = str3{val3};                                  % linkage
        par4 = get(handles.par1_4,'Value');                 % to create or not dendrogram (0:no, 1:yes)
        centers = 0;                                        % no centers available
        % Validate parameters
        if isequalwithequalnans(par1,NaN)
            errordlg('Number of clusters must be numeric','Invalid Parameter','modal')
            allOK = 0;
        else
            info = 'Hierarchical Clustering done.';
            allOK = 1;

            % Update parameters
            par1 = round(par1);
            parameters.nrClusters = par1;
            parameters.metric = par2;
            parameters.linkage = par3;
        end
        
    case 'K-Means'
        par1 = str2double(get(handles.par2_1,'String'));    % convert nr of clusters to integer
        str2 = get(handles.par2_2,'String'); val2 = get(handles.par2_2,'Value');
        par2 = str2{val2};                                  % distance metric
        par3 = str2double(get(handles.par2_3,'String'));    % convert nr of replicates to integer
        par4 = get(handles.par2_4,'Value');                 % to create or not silhouette (0:no, 1:yes)
        % Validate parameters
        if isequalwithequalnans(par1,NaN)
            errordlg('Number of clusters must be numeric','Invalid Parameter','modal')
            allOK = 0;
        elseif par1 < 2
            errordlg('Minimum number of clusters is 2','Invalid Parameter','modal')
            allOK = 0;
        elseif isequalwithequalnans(par3,NaN)
            errordlg('Number of replications must be numeric','Invalid Parameter','modal')
            allOK = 0;    
        else
            info = 'K-Means Clustering done.';
            allOK = 1;
            
            % Update parameters
            par1 = round(par1);
            par3 = round(par3);
            parameters.nrClusters = par1;
            parameters.metric = par2;
            parameters.replicates = par3;
        end

    case 'Fuzzy C-Means'
        par1 = str2double(get(handles.par3_1,'String'));        % convert nr of clusters to integer
        exp = str2double(get(handles.par3_2,'String'));         % convert exp to double
        maximum = str2double(get(handles.par3_3,'String'));     % convert maximum to integer
        minimum = str2double(get(handles.par3_4,'String'));     % convert minimum to double
        % Validate parameters
        if isequalwithequalnans(par1,NaN) || isequalwithequalnans(exp,NaN) || isequalwithequalnans(maximum,NaN) || isequalwithequalnans(minimum,NaN)
            errordlg('All parameters must be numeric','Invalid Parameter','modal')
            allOK = 0;
        else
            par2 = [exp round(maximum) minimum 0];
            par3 = 0;
            par4 = 0;
            info = 'Fuzzy C-Means Clustering done.';
            allOK = 1;

            % Update parameters
            par1 = round(par1);
            parameters.nrClusters = par1;
            parameters.exponent = exp;
            parameters.maxIterations = maximum;
            parameters.minImprovement = minimum;
        end

    case 'Fuzzy Subtractive'
        par1 = str2double(get(handles.par4_1,'String'));    % convert range to double
        qs = str2double(get(handles.par4_2,'String'));      % convert quash to double
        ac = str2double(get(handles.par4_3,'String'));      % convert accept to double
        rj = str2double(get(handles.par4_4,'String'));      % convert reject to double
        % Validate parameters
        if isequalwithequalnans(par1,NaN) || isequalwithequalnans(qs,NaN) || isequalwithequalnans(ac,NaN) || isequalwithequalnans(rj,NaN)
            errordlg('All parameters must be numeric','Invalid Parameter','modal')
            allOK = 0;
        else
            par2 = [qs ac rj 0];
            par3 = 0;
            par4 = 0;
            info = 'Fuzzy Subtractive Clustering done.';
            moreInfo = 1;
            allOK = 1;

            % Update parameters
            parameters.range = par1;
            parameters.quash = qs;
            parameters.accept = ac;
            parameters.reject = rj;
        end

    case 'Dignet'
        str2 = get(handles.par5_2,'String'); val2 = get(handles.par5_2,'Value');
        par1 = str2double(get(handles.par5_1,'String'));    % convert threshold to double
        par2 = str2{val2};                                  % distance metric
        par3 = 0;
        par4 = 0;
        % Validate parameters
        if isequalwithequalnans(par1,NaN)
            errordlg('Threshold must be numeric','Invalid Parameter','modal')
            allOK = 0;
        else
            info = 'Dignet Clustering done.';
            moreInfo = 1;
            allOK = 1;

            % Update parameters
            parameters.threshold = par1;
            parameters.metric = par2;
        end

    case 'SOM'
        handles.som_data=get(handles.par6_1,'Value');   % 1:reduced, 2:original

        % Update and get GUI data
        guidata(hObject, handles);
        mydata = guidata(hObject);

        %Open selected GUI
        sel=get(handles.par6_0,'Value');
        if sel==1
            info = 'SOM Clustering Interface opened.';
            SomClusteringGUI(mydata); % Run SOM GUI
        elseif sel==2
            info = 'Recursive SOM Interface opened.';
            RecSomGUI(mydata);          % Run RecSOM GUI
        end
        
        itensSave='off';
        doClustering = 0;
        allOK = 1;
    otherwise
end

% If no errors
if allOK == 1
    % If clustering
    
    % Delete clusteringData structure
    if isfield(handles,'clusteringData')
        handles = rmfield(handles,'clusteringData');
    end

    if doClustering == 1
        [clusters clustCenters] = Clustering(method,data,par1,par2,par3,par4,centers); %run graphic function and save cluster indexes

        % Activate datacursor
        mylabels(data, handles.labels)

        % Complete info
        if moreInfo == 1
            info = [info ' Created ' num2str(max(clusters)) ' clusters.'];
            parameters.nrClusters = max(clusters);
        end
        
        % Update structure
        handles.clusteringData.type = 'classic';
        handles.clusteringData.method = method;
        handles.clusteringData.clusters = clusters;
        if ~isempty(clustCenters)
            handles.clusteringData.centers = clustCenters;
        end
        handles.clusteringData.parameters = parameters;
        handles.clusteringData.parameters.dimension = size(data,2);
    end

    % Update Info
    set(handles.list_clust_info,'String',strvcat(get(handles.list_clust_info,'String'),info));

    % Set save panel visible
    set(handles.panel_save,'visible','on');
    set([handles.rad_mat handles.rad_xls handles.rad_work handles.save],'Enable',itensSave);

    % Save data in handles
    guidata(hObject, handles);
end

% --- Executes during object creation, after setting all properties.
function list_clust_info_CreateFcn(hObject, eventdata, handles)
% hObject    handle to list_clust_info (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% - Save Panel

% --- Executes on button press in rad_mat.
function rad_mat_Callback(hObject, eventdata, handles)
% hObject    handle to rad_mat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.rad_mat,'Value',1.0);
set(handles.rad_xls,'Value',0.0);
set(handles.rad_work,'Value',0.0);

% --- Executes on button press in rad_xls.
function rad_xls_Callback(hObject, eventdata, handles)
% hObject    handle to rad_xls (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.rad_xls,'Value',1.0);
set(handles.rad_mat,'Value',0.0);
set(handles.rad_work,'Value',0.0);

% --- Executes on button press in rad_work.
function rad_work_Callback(hObject, eventdata, handles)
% hObject    handle to rad_work (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.rad_work,'Value',1.0);
set(handles.rad_mat,'Value',0.0);
set(handles.rad_xls,'Value',0.0);

% --- Executes on button press in save.
function save_Callback(hObject, eventdata, handles)
% hObject    handle to save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get mat, xls or workspace save mode
save_m1=get(handles.rad_mat,'Value');   %1:MAT-File
save_m2=get(handles.rad_xls,'Value');   %1:Excel
save_m3=get(handles.rad_work,'Value');  %1:Workspace

if save_m2==1      %Excel
    data = handles.reducedData.dataMatrix;  %get matrix from dimension reduction
    
    % Variables to send to Save GUI
    if handles.clusteringData.parameters.dimension == 3;
        send.data=data(:,1:3);               %use 3 dimensions
        send.header = {'1st Dimension' '2nd Dimension' '3rd Dimension'};
    else
        send.data=data(:,1:2);               %use 2 dimensions
        send.header = {'1st Dimension' '2nd Dimension'};
    end
    send.save_method = 0;               %0:Clustering; 1:SOM
    send.labels = handles.labels;
    send.clusters = handles.clusteringData.clusters;
    send.text = [handles.clusteringData.method ' Clustering'];
    
    input=SaveXls(send);   % run Save GUI
    % Update Info
    if input==1
        str=get(handles.list_clust_info,'String');
        set(handles.list_clust_info,'String',strvcat(str,'Results saved to Excel File.'));
    end
    
elseif save_m1==1  %MAT-File
    % Save dialog
    [a,b]=uiputfile('*.mat','Save Reduced Matrix and Clustering Results');

    if isequal([a,b],[0,0])
        return
    else
        c=strcat(b,a);

        % Get structures to save
        if isfield(handles,'rawData')
            rawData = handles.rawData;
        end
        labels = handles.labels;
        reducedData = handles.reducedData;
        clusteringData = handles.clusteringData;

        % Save all structures:
        if isfield(handles,'rawData')
            save (c,'rawData','labels','reducedData','clusteringData')
        else
            save (c,'labels','reducedData','clusteringData')
        end

        % Update Info
        str=get(handles.list_clust_info,'String');
        set(handles.list_clust_info,'String',strvcat(str,['Results saved to MAT-File: ' a]));
    end

elseif save_m3==1  %Workspace
    % Save all structures:
    if isfield(handles,'rawData')
        assignin('base','rawData', handles.rawData);
    end
    assignin('base','labels', handles.labels);
    assignin('base','reducedData', handles.reducedData);
    assignin('base','clusteringData', handles.clusteringData);

    % Update Info
    str=get(handles.list_clust_info,'String');
    set(handles.list_clust_info,'String',strvcat(str,'Results sent to Workspace.'));
end

%% SUB-FUNCTIONS AREA
% --- Functions to set datacursor information
function mylabels(data,labels)
    %Rotines to activate datacursor:
    if size(data,2)==2
        plot(data(:,1),data(:,2),'.','markersize',.5,'color','w');    %white plot
    else
        plot3(data(:,1),data(:,2),data(:,3),'.','markersize',.5,'color','w');    %white plot
    end
    dcm_obj = datacursormode;
    set(dcm_obj,'DisplayStyle','datatip','SnapToDataVertex','on',...
        'Enable','on','UpdateFcn',{@myupdatefcn,labels})


function txt = myupdatefcn(empt,event_obj,labels)
    pos = get(event_obj,'DataIndex');
    nrOfLabels = length(labels.header);
    txt=cell(1,nrOfLabels);
    for i=1: nrOfLabels
        aux = [char(labels.header(i)) ': ' char(labels.(['Label_' num2str(i)])(pos))];
        txt(i) = {aux};
    end
 
function txt = rawLabelsFunction(empt,event_obj,labels,dcm_obj, auxiliarInfo)

    pos = get(event_obj,'DataIndex');
    variable = get(event_obj,'Target');

    nrOfLabels = length(labels.header);    
    txt = cell(1,nrOfLabels+1);
   
    txt(1) = labels.varNames(find(variable==auxiliarInfo));
    for i=1: nrOfLabels
        aux = [char(labels.header(i)) ': ' char(labels.(['Label_' num2str(i)])(pos))];
        txt(i+1) = {aux};
    end    


%% START MENU FUNCTIONS
% --------------------------------------------------------------------
function help_menu_Callback(hObject, eventdata, handles)
% hObject    handle to help_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

function menu_about_Callback(hObject, eventdata, handles)
% hObject    handle to menu_about (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

text={'VISRED - Data Visualization by Space Reduction';' ';
    'Version 1.2r';'Updated April 20, 2007';' ';
    'Antnio Dourado';'Edgar Ferreira';'Paulo Barbeiro';' ';
    'FCTUC - Coimbra, Portugal';' ';' ';
    'Suported by CLASSE Project POSC/EEI/58162/2004 FCT and FEDER';' ';
    'Copyright (C) 2007 Antnio Dourado, Edgar Ferreira, Paulo Barbeiro';' ';...
    'VISRED comes with ABSOLUTELY NO WARRANTY;';...
    'for details type "help VisRedGUI". This is free software,';...
    'and you are welcome to redistribute it under certain conditions;';...
    'see "License EN.txt" or "License PT.txt" for more details.';' ';
    'For citation';'Dourado A., E. Ferreira, P. Barbeiro';
    'VISRED:Numerical Data Mining with Linear and Nonlinear Techniques';
    'P. Perner (Ed.): ICDM 2007, LNAI 4597, pp. 92-106, 2007';
    'Springer-Verlag Berlin Heidelberg 2007'};
msgbox(text,'About VISRED');

% --- Executes on button press in restart_button.
function restart_button_Callback(hObject, eventdata, handles)
% hObject    handle to restart_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Reset all invisible and disable objects
set([handles.raw_log_panel handles.dissimilarities_panel handles.var_red_method_panel handles.MDS_parameters handles.dim_red_panel, ...
    handles.cmd_analysis_panel handles.panel_alg handles.panel_save handles.panel_clust_info handles.select_arr, ...
    handles.title_arr],'visible','off');
set(handles.save_red,'enable','off');

% Set default Clustering values and strings
set(handles.panel_hierar,'visible','off');
set(handles.panel_kmeans,'visible','off');
set(handles.panel_cmeans,'visible','off');
set(handles.panel_sub,'visible','off');
set(handles.panel_dignet,'visible','off');
set(handles.panel_som,'visible','off');
set(handles.panel_create_clusters,'visible','off');
set([handles.clust_alg handles.clust_dim handles.rad_mat, ...
    handles.par1_2 handles.par1_3 handles.par2_2, ...
    handles.par5_2 handles.par6_0 handles.par6_1],'value',1);
set([handles.centers handles.rad_xls handles.rad_work, ...
    handles.par1_4 handles.par2_4],'value',0);
set([handles.par1_1 handles.par2_1 handles.par2_3 handles.par3_1],'String','5');
set([handles.par3_2],'String','2.0');
set([handles.par3_3],'String','100');
set([handles.par3_4],'String','1e-5');
set([handles.par4_1],'String','0.3');
set([handles.par4_2],'String','1.25');
set([handles.par4_3],'String','0.5');
set([handles.par4_4],'String','0.15');
set([handles.par5_1],'String','0.45');
set([handles.list_clust_info],'String','');

set([handles.excel_sheet_list,...
    handles.start_txt...
    handles.end_txt...
    handles.start_edit...
    handles.read_raw_button...
    handles.end_edit...
    handles.plot_clust],'enable','off');
set(handles.excel_sheet_list,'string','');

set([handles.load_file handles.select_exel_file_button],'enable','on');

% Clear handles
clear all;
clear global;


